Bug 1661252 (CVE-2018-1000845) - CVE-2018-1000845 avahi: DNS amplification and reflection to spoofed addresses
Summary: CVE-2018-1000845 avahi: DNS amplification and reflection to spoofed addresses
Keywords:
Status: CLOSED DUPLICATE of bug 1426712
Alias: CVE-2018-1000845
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1661253
Blocks: 1661254
TreeView+ depends on / blocked
 
Reported: 2018-12-20 15:33 UTC by Pedro Sampaio
Modified: 2019-09-29 15:04 UTC (History)
12 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-01-31 08:18:03 UTC


Attachments (Terms of Use)

Description Pedro Sampaio 2018-12-20 15:33:24 UTC
Avahi-daemon in Avahi through 0.7 inadvertently sends Legacy Unicast
Responses to IPv4 unicast queries with source addresses that are not
link-local, which allows remote attackers to cause a denial of service
(traffic amplification) or obtain potentially sensitive information
via port-5353 UDP packets.

send(IP(src="1.1.1.1",dst="192.168.1.1")/UDP(sport=53,
dport=5353)/DNS(rd=1,qd=DNSQR(qtype="PTR", qname="_ssh._tcp.local.")))

Upstream issue:

https://github.com/lathiat/avahi/issues/203

Comment 1 Pedro Sampaio 2018-12-20 15:33:36 UTC
Created avahi tracking bugs for this issue:

Affects: fedora-all [bug 1661253]

Comment 2 Nicholas Luedtke 2018-12-20 17:47:38 UTC
This looks to be CVE-2018-1000845.

Comment 3 Trent Lloyd 2018-12-22 01:29:49 UTC
I have pushed a fix upstream for the issue here:
https://github.com/lathiat/avahi/commit/e111def44a7df4624a4aa3f85fe98054bffb6b4f

I have only performed basic validation so far, however the following scapy query now fails:
send(IP(src="1.1.1.1",dst="DEST_IP")/UDP(sport=53, dport=5353)/DNS(rd=1,qd=DNSQR(qtype="PTR", qname="_ssh._tcp.local.")))

And the following legitimate legacy unicast query still works:
dig HOSTNAME.local @DEST_IP -p 5353


Note that for the test scapy to work, you have to publish an _ssh._tcp service, e.g. put the example ssh.service into /etc/avahi/services. To avoid that, you can query for the machine's mdns hostname as an A record instead.
send(IP(src="1.1.1.1",dst="DEST_IP")/UDP(sport=53, dport=5353)/DNS(rd=1,qd=DNSQR(qtype="A", qname="HOSTNAME.local.")))

Comment 4 Riccardo Schirone 2019-01-02 13:35:50 UTC
This appears to be a duplicate of CVE-2017-6519.

Comment 5 Riccardo Schirone 2019-01-02 14:21:37 UTC
Setting Availability in CVSSv3 to Low because of the rate-limiting feature enabled by default in Avahi, that allows to generate a maximum of 1000 packets per second (which can be configured with the ratelimit-interval-usec and ratelimit-burst options in /etc/avahi/avahi-daemon.conf)

Comment 6 Riccardo Schirone 2019-01-02 14:24:19 UTC
Mitigation:

Ensure UDP port 5353 is blocked in the firewall. Moreover, configure correctly the rate limiting options based on your needs (see ratelimit-interval-usec and ratelimit-burst options in /etc/avahi/avahi-daemon.conf).

Comment 7 Riccardo Schirone 2019-01-03 09:57:37 UTC
Requested MITRE to mark this CVE as a duplicate of CVE-2017-6519.

Comment 8 Riccardo Schirone 2019-01-31 08:18:03 UTC
This flaw has been rejected by MITRE as a duplicate of CVE-2017-6519.

*** This bug has been marked as a duplicate of bug 1426712 ***


Note You need to log in before you can comment on or make changes to this bug.